/*
 * Copyright (c) 2019 University of Colorado
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Author: Derek Hageman <Derek.Hageman@noaa.gov>
 */


#ifndef CPD3LUASCRIPT_STREAMBUFFER_HXX
#define CPD3LUASCRIPT_STREAMBUFFER_HXX

#include "core/first.hxx"

#include <memory>

#include "luascript.hxx"
#include "engine.hxx"
#include "datacore/stream.hxx"
#include "datacore/segment.hxx"

namespace CPD3 {
namespace Lua {

/**
 * The base class implementing a stream buffer.  This can be used as either a Lua object
 * where the script code generally executes a loop on it, or as a controller where the
 * C++ code calls into a Lua handler for every value produced.
 * <br>
 * It does NOT provide any threaded synchronization, so if used in that way, it must
 * wrapping code must synchronize the incoming values with the thread executing the
 * script code.
 */
class CPD3LUASCRIPT_EXPORT StreamBuffer {
    class Context;

    friend class StreamBuffer::Context;

    std::shared_ptr<StreamBuffer::Context> context;

    class BaseController;

    class LuaController;

    class ExternalController;

public:
    StreamBuffer();

    virtual ~StreamBuffer();

    StreamBuffer(const StreamBuffer &) = delete;

    StreamBuffer &operator=(const StreamBuffer &) = delete;

    StreamBuffer(StreamBuffer &&) = delete;

    StreamBuffer &operator=(StreamBuffer &&) = delete;


    /**
     * Push an object on to the frame that can be used by Lua script to control
     * the buffer.  This object allows the Lua code to loop over all values
     * generated by the buffer.
     *
     * @param target    the frame to push on to
     */
    void pushLuaController(Engine::Frame &target);

    /**
     * Push an object on the the frame that can be used by an external controller
     * to invoke Lua script repeatedly to iterate over generated values.  This
     * controller can also be used by the Lua script to control parameters of
     * the buffer, but not advance it.
     *
     * @param target    the frame to push on to
     * @see pushExternal(Engine::Frame &, const Engine::Reference &)
     */
    void pushExternalController(Engine::Frame &target);

    /**
     * Push the next value of the buffer under external control on to the target
     * frame.  This is normally used as part of a loop invoking a Lua handler.
     *
     * @param target        the frame to push on to
     * @param controller    the controller object
     * @param ignoreEnd     set to true to ignore a false result from pushNext(Engine::Frame &) and simply return false
     * @return              true if a value was pushed or false on the end of the buffer
     */
    bool pushExternal(Engine::Frame &target,
                      const Engine::Reference &controller,
                      bool ignoreEnd = false);

    /**
     * Finish the buffer, releasing all pending values.  This is normally used after
     * the Lua script exits to complete releasing anything remaining.
     *
     * @param frame         the current engine frame
     * @param controller    the controller
     * @return              the final time the buffer finished at
     */
    double finish(Engine::Frame &frame, const Engine::Reference &controller);

    class Value;

    class Segment;

protected:
    /**
     * Push the next value in the buffer on to a frame.  This is called by the
     * control state whenever the buffer needs to advance.  It should push either
     * a single number for a pure time advance or anything else to process that
     * value.
     *
     * @param target        the target frame
     * @return              true if a value was pushed and the buffer should continue or false on the end of the buffer
     */
    virtual bool pushNext(Engine::Frame &target) = 0;

    /**
     * Get the start time of a buffered value.  This is called by the control state
     * to determine when a value starts so it can be correctly located in the buffer.
     *
     * @param frame         the current engine frame
     * @param ref           the reference to the value
     * @return              the start time of the value
     */
    virtual double getStart(Engine::Frame &frame, const Engine::Reference &ref) = 0;

    /**
     * Convert a value created by the Lua code to one that can be stored in the buffer.
     * This normally involves constructing the internal storage user data type for
     * faster access.
     *
     * @param frame         the current frame, with the value as the back of it
     */
    virtual void convertFromLua(Engine::Frame &frame);

    /**
     * Called by the control state whenever a value is ready for output.
     *
     * @param frame         the current frame
     * @param ref           the value that has become ready
     */
    virtual void outputReady(Engine::Frame &frame, const Engine::Reference &ref) = 0;

    /**
     * Called by the control state to indicate that the output can be advanced.
     *
     * @param time          the time to advance to
     */
    virtual void advanceReady(double time);

    /**
     * Called by the control state when the buffer output has been ended.
     */
    virtual void endReady() = 0;

    /**
     * Called when an assignment on an index in the buffer is attempted.
     *
     * @param frame         the current frame
     * @param target        the reference to the assigned index
     * @param value         the value being assigned to it
     * @return              true if the assignment is valid
     */
    virtual bool bufferAssigned(Engine::Frame &frame,
                                const Engine::Reference &target,
                                const Engine::Reference &value);
};

/**
 * A stream buffer type that implements the common operations for handling
 * a stream of SequenceValues.
 */
class CPD3LUASCRIPT_EXPORT StreamBuffer::Value : public StreamBuffer {
public:
    Value();

    virtual ~Value();

    /**
     * Extract a sequence value from a reference.  This is usually called from the
     * implementation's outputReady(Engine::Frame &, const Engine::Reference &).
     *
     * @param frame the current frame
     * @param ref   the reference to extract
     * @return      the converted value
     */
    static CPD3::Data::SequenceValue extract(Engine::Frame &frame, const Engine::Reference &ref);

protected:
    double getStart(Engine::Frame &frame, const Engine::Reference &ref) override;

    void convertFromLua(Engine::Frame &frame) override;
};

class CPD3LUASCRIPT_EXPORT StreamBuffer::Segment : public StreamBuffer {
public:
    Segment();

    virtual ~Segment();

    /**
     * Convert the sequence segment into a set of values.  This is usually called from the
     * implementation's outputReady(Engine::Frame &, const Engine::Reference &).
     *
     * @param frame         the current frame
     * @param ref           the reference to extract
     * @param outputs       the set of outputs to extract from it
     * @param requireExists only extract values that exist
     * @return              the extracted values
     */
    static CPD3::Data::SequenceValue::Transfer extract(Engine::Frame &frame,
                                                       const Engine::Reference &ref,
                                                       const CPD3::Data::SequenceName::Set &outputs,
                                                       bool requireExists = true);

protected:
    double getStart(Engine::Frame &frame, const Engine::Reference &ref) override;

    void convertFromLua(Engine::Frame &frame) override;
};

}
}

#endif //CPD3LUASCRIPT_STREAMBUFFER_HXX
